Index: sansview/test/sphere_60_q0_2.txt
===================================================================
--- sansview/test/sphere_60_q0_2.txt	(revision 111acd25063671b24942c807545ed850ffcdc11f)
+++ sansview/test/sphere_60_q0_2.txt	(revision 111acd25063671b24942c807545ed850ffcdc11f)
@@ -0,0 +1,100 @@
+<X>   <Y>
+0.0030303  8.98814e+007
+0.00606061  8.8112e+007
+0.00909091  8.52294e+007
+0.0121212  8.13294e+007
+0.0151515  7.65401e+007
+0.0181818  7.10151e+007
+0.0212121  6.49267e+007
+0.0242424  5.84579e+007
+0.0272727  5.17944e+007
+0.030303  4.51165e+007
+0.0333333  3.8592e+007
+0.0363636  3.237e+007
+0.0393939  2.65755e+007
+0.0424242  2.13065e+007
+0.0454545  1.66317e+007
+0.0484848  1.25902e+007
+0.0515152  9.19312e+006
+0.0545455  6.42579e+006
+0.0575758  4.25154e+006
+0.0606061  2.61612e+006
+0.0636364  1.45255e+006
+0.0666667  686135
+0.069697  239279
+0.0727273  35857.1
+0.0757576  4919.12
+0.0787879  83577.3
+0.0818182  218998
+0.0848485  369480
+0.0878788  504676
+0.0909091  605048
+0.0939394  660716
+0.0969697  669852
+0.1  636816
+0.10303  570197
+0.106061  480922
+0.109091  380565
+0.112121  279960
+0.115152  188168
+0.118182  111825
+0.121212  54863.4
+0.124242  18561.6
+0.127273  1856.11
+0.130303  1846.07
+0.133333  14403.8
+0.136364  34814.1
+0.139394  58372.5
+0.142424  80888.4
+0.145455  99054.8
+0.148485  110668
+0.151515  114694
+0.154545  111202
+0.157576  101181
+0.160606  86290.3
+0.163636  68568
+0.166667  50137
+0.169697  32946.5
+0.172727  18566.1
+0.175758  8051.8
+0.178788  1887.73
+0.181818  1.4079
+0.184848  1840.78
+0.187879  6497.1
+0.190909  12853.9
+0.193939  19742.4
+0.19697  26083.9
+0.2  31005.7
+0.20303  33919.7
+0.206061  34558
+0.209091  32968.3
+0.212121  29471.6
+0.215152  24593.2
+0.218182  18977.1
+0.221212  13295.2
+0.224242  8163.18
+0.227273  4071.6
+0.230303  1339.39
+0.233333  92.2766
+0.236364  266.593
+0.239394  1635.41
+0.242424  3851.68
+0.245455  6501.71
+0.248485  9161.49
+0.251515  11449
+0.254545  13066.6
+0.257576  13829.3
+0.260606  13676.9
+0.263636  12669.9
+0.266667  10971.1
+0.269697  8816.65
+0.272727  6480.3
+0.275758  4236.72
+0.278788  2327.4
+0.281818  933.697
+0.284848  159.476
+0.287879  24.6054
+0.290909  469.318
+0.293939  1367.95
+0.29697  2549.68
+0.3  3823.11
Index: sansview/test/sphere_80.txt
===================================================================
--- sansview/test/sphere_80.txt	(revision 111acd25063671b24942c807545ed850ffcdc11f)
+++ sansview/test/sphere_80.txt	(revision 111acd25063671b24942c807545ed850ffcdc11f)
@@ -0,0 +1,100 @@
+<X>   <Y>
+0.0010101  2.14186e+008
+0.0020202  2.13348e+008
+0.0030303  2.11958e+008
+0.0040404  2.10025e+008
+0.00505051  2.07561e+008
+0.00606061  2.04584e+008
+0.00707071  2.01112e+008
+0.00808081  1.97169e+008
+0.00909091  1.92781e+008
+0.010101  1.87975e+008
+0.0111111  1.82783e+008
+0.0121212  1.77237e+008
+0.0131313  1.71373e+008
+0.0141414  1.65226e+008
+0.0151515  1.58833e+008
+0.0161616  1.52233e+008
+0.0171717  1.45465e+008
+0.0181818  1.38567e+008
+0.0191919  1.31578e+008
+0.020202  1.24536e+008
+0.0212121  1.17479e+008
+0.0222222  1.10442e+008
+0.0232323  1.03461e+008
+0.0242424  9.65692e+007
+0.0252525  8.97973e+007
+0.0262626  8.31748e+007
+0.0272727  7.67288e+007
+0.0282828  7.04839e+007
+0.0292929  6.4462e+007
+0.030303  5.86828e+007
+0.0313131  5.31627e+007
+0.0323232  4.79158e+007
+0.0333333  4.29533e+007
+0.0343434  3.82836e+007
+0.0353535  3.39126e+007
+0.0363636  2.98434e+007
+0.0373737  2.60768e+007
+0.0383838  2.2611e+007
+0.0393939  1.9442e+007
+0.040404  1.65639e+007
+0.0414141  1.39687e+007
+0.0424242  1.16467e+007
+0.0434343  9.58662e+006
+0.0444444  7.77602e+006
+0.0454545  6.20118e+006
+0.0464646  4.84751e+006
+0.0474747  3.69971e+006
+0.0484848  2.74197e+006
+0.0494949  1.95815e+006
+0.0505051  1.33203e+006
+0.0515152  847402
+0.0525253  488319
+0.0535354  239201
+0.0545455  84994.7
+0.0555556  11292.7
+0.0565657  4445.63
+0.0575758  51653.5
+0.0585859  141041
+0.059596  261717
+0.0606061  403816
+0.0616162  558522
+0.0626263  718084
+0.0636364  875805
+0.0646465  1.02603e+006
+0.0656566  1.1641e+006
+0.0666667  1.28634e+006
+0.0676768  1.38998e+006
+0.0686869  1.47309e+006
+0.069697  1.53454e+006
+0.0707071  1.57391e+006
+0.0717172  1.59141e+006
+0.0727273  1.5878e+006
+0.0737374  1.5643e+006
+0.0747475  1.52256e+006
+0.0757576  1.46449e+006
+0.0767677  1.39227e+006
+0.0777778  1.30823e+006
+0.0787879  1.21477e+006
+0.079798  1.11433e+006
+0.0808081  1.00933e+006
+0.0818182  902079
+0.0828283  794770
+0.0838384  689421
+0.0848485  587856
+0.0858586  491670
+0.0868687  402219
+0.0878788  320609
+0.0888889  247687
+0.089899  184050
+0.0909091  130047
+0.0919192  85790.3
+0.0929293  51176.4
+0.0939394  25900.5
+0.0949495  9481.12
+0.0959596  1283.93
+0.0969697  547.497
+0.0979798  6409.98
+0.0989899  17935.9
+0.1  34142.4