Index: docs/sphinx-docs/build_sphinx.py
===================================================================
--- docs/sphinx-docs/build_sphinx.py	(revision 751f4bdb1383a4267910b9a189f51206749158e0)
+++ docs/sphinx-docs/build_sphinx.py	(revision 115eb7e10c3b635f94012498785ab1e76a17614b)
@@ -206,4 +206,5 @@
                     tohere=os.path.join(SASMODELS_DEST_PROLOG,files)
                     shutil.copy(fromhere,tohere)
+    else: print "no source directory",SASMODELS_SOURCE_PROLOG, "was found"
 
     if os.path.exists(SASMODELS_SOURCE_GPU):
@@ -217,4 +218,5 @@
                     tohere=os.path.join(SPHINX_SOURCE_USER,files)
                     shutil.copy(fromhere,tohere)
+    else: print "no source directory",SASMODELS_SOURCE_GPU," was found"
 
     if os.path.exists(SASMODELS_SOURCE_SESANS):
@@ -228,4 +230,5 @@
                     tohere=os.path.join(SPHINX_SOURCE_USER,files)
                     shutil.copy(fromhere,tohere)
+    else: print "no source directory",SASMODELS_SOURCE_SESANS," was found"
 
     if os.path.exists(SASMODELS_SOURCE_MAGNETISM):
@@ -239,4 +242,5 @@
                     tohere=os.path.join(SASMODELS_DEST_REF_MODELS,files)
                     shutil.copy(fromhere,tohere)
+    else: print "no source directory",SASMODELS_SOURCE_MAGNETISM," was found"
 
     if os.path.exists(SASMODELS_SOURCE_MAGIMG):
@@ -276,19 +280,20 @@
                     tohere=os.path.join(SASMODELS_DEST_REF_MODELS,files)
                     shutil.copy(fromhere,tohere)
-    # But need to change the path to the model docs in the tocs
-    for files in os.listdir(SASMODELS_DEST_REF_MODELS):
-#        print files
-        if files.startswith("shape"):
-            print "Changing toc paths in", files
-            inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
-        if files.startswith("sphere"):
-            print "Changing toc paths in", files
-            inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
-        if files.startswith("custom"):
-            print "Changing toc paths in", files
-            inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
-        if files.startswith("structure"):
-            print "Changing toc paths in", files
-            inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
+            # But need to change the path to the model docs in the tocs
+            for files in os.listdir(SASMODELS_DEST_REF_MODELS):
+        #        print files
+                if files.startswith("shape"):
+                    print "Changing toc paths in", files
+                    inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
+                if files.startswith("sphere"):
+                    print "Changing toc paths in", files
+                    inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
+                if files.startswith("custom"):
+                    print "Changing toc paths in", files
+                    inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
+                if files.startswith("structure"):
+                    print "Changing toc paths in", files
+                    inplace_change(os.path.join(SASMODELS_DEST_REF_MODELS,files), "../../model/", "models/")
+    else: print "no source directory",SASMODELS_SOURCE_REF_MODELS," was found"
 
     if os.path.exists(SASMODELS_SOURCE_MODELS):
@@ -320,4 +325,5 @@
                 tohere=os.path.join(SASMODELS_DEST_BUILDIMG,files)
                 shutil.copy(fromhere,tohere)
+    else: print "no source directory",SASMODELS_SOURCE_MODELS," was found.\n !!!!NO MODEL DOCS WILL BE BUILT!!!!"
 
 
Index: setup.py
===================================================================
--- setup.py	(revision f3bf622b821c651bb6e946100b07e15cd59331fe)
+++ setup.py	(revision 115eb7e10c3b635f94012498785ab1e76a17614b)
@@ -152,4 +152,18 @@
 
     def run(self):
+        ''' First builds the sasmodels documentation if the directory
+        is present. Then builds the sasview docs.
+        '''
+        ### AJJ - Add code for building sasmodels docs here:
+        # check for doc path
+        SASMODELS_PATH = '../sasmodels'
+        if os.path.exists(SASMODELS_PATH):
+            if os.path.isdir(SASMODELS_PATH):
+                # if available, build sasmodels docs
+            else:
+                # if not available warning message
+                print "WARNING!! sasmodels directory not found. Cannot build model docs."
+
+        #Now build sasview (+sasmodels) docs
         sys.path.append("docs/sphinx-docs")
         import build_sphinx