Index: prview/perspectives/pr/inversion_panel.py
===================================================================
--- prview/perspectives/pr/inversion_panel.py	(revision 634f1cf6c63e6c8c347746c746ab4dc929ec8540)
+++ prview/perspectives/pr/inversion_panel.py	(revision 119a11dfe2414910cd2dd3218210909b8b0d3e62)
@@ -244,5 +244,5 @@
         explanation += "The minimization involves a regularization term to ensure "
         explanation += "a smooth P(r). The alpha parameter gives the size of that "  
-        explanation += "term. The suggested value is the value above which the"
+        explanation += "term. The suggested value is the value above which the "
         explanation += "output P(r) will have only one peak."
         label_explain = wx.StaticText(self, -1, explanation, size=(280,80))
@@ -526,4 +526,41 @@
         
 
+
+
+class HelpDialog(wx.Dialog):
+    def __init__(self, parent, id):
+        from sans.pr.invertor import help
+        wx.Dialog.__init__(self, parent, id, size=(400, 400))
+        self.SetTitle("P(r) help") 
+        
+
+        vbox = wx.BoxSizer(wx.VERTICAL)
+
+        explanation = help()
+           
+        label_explain = wx.StaticText(self, -1, explanation, size=(350,300))
+            
+        vbox.Add(label_explain, 0, wx.ALL|wx.EXPAND, 15)
+
+
+        static_line = wx.StaticLine(self, -1)
+        vbox.Add(static_line, 0, wx.EXPAND, 0)
+        
+        button_OK = wx.Button(self, wx.ID_OK, "OK")
+        #button_Cancel = wx.Button(self, wx.ID_CANCEL, "Cancel")
+        
+        sizer_button = wx.BoxSizer(wx.HORIZONTAL)
+        sizer_button.Add((20, 20), 1, wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+        sizer_button.Add(button_OK, 0, wx.LEFT|wx.RIGHT|wx.ADJUST_MINSIZE, 10)
+        #sizer_button.Add(button_Cancel, 0, wx.LEFT|wx.RIGHT|wx.ADJUST_MINSIZE, 10)        
+        vbox.Add(sizer_button, 0, wx.EXPAND|wx.BOTTOM|wx.TOP, 10)
+
+        self.SetSizer(vbox)
+        self.SetAutoLayout(True)
+        
+        self.Layout()
+        self.Centre()
+
+
 class ParsDialog(wx.Panel):
     """
@@ -666,14 +703,7 @@
     def OnInit(self):
         wx.InitAllImageHandlers()
-        plots = {}
-        plots['a'] = TestPlot("data 1")
-        plots['b'] = TestPlot("data 2")
-        #plots['c'] = TestPlot("data 3")
-        #plots['d'] = TestPlot("data 1")
-        #plots['e'] = TestPlot("data 2")
-        #plots['f'] = TestPlot("data 3")
-        dialog = InversionDlg(None, -1, "P(r) parameters", plots)
+        dialog = HelpDialog(None, -1)
         if dialog.ShowModal() == wx.ID_OK:
-            print dialog.get_content()
+            pass
         dialog.Destroy()
         
Index: prview/perspectives/pr/pr.py
===================================================================
--- prview/perspectives/pr/pr.py	(revision 634f1cf6c63e6c8c347746c746ab4dc929ec8540)
+++ prview/perspectives/pr/pr.py	(revision 119a11dfe2414910cd2dd3218210909b8b0d3e62)
@@ -58,5 +58,18 @@
         shapes.Append(id, '&Sphere test')
         wx.EVT_MENU(owner, id, self._fit_pr)
+        
         return [(id, shapes, "P(r)")]
+    
+    def help(self, evt):
+        """
+            Show a general help dialog. 
+            TODO: replace the text with a nice image
+        """
+        from inversion_panel import HelpDialog
+        dialog = HelpDialog(None, -1)
+        if dialog.ShowModal() == wx.ID_OK:
+            dialog.Destroy()
+        else:
+            dialog.Destroy()
     
     def _fit_pr(self, evt):
Index: prview/perspectives/pr/requirements.txt
===================================================================
--- prview/perspectives/pr/requirements.txt	(revision 634f1cf6c63e6c8c347746c746ab4dc929ec8540)
+++ prview/perspectives/pr/requirements.txt	(revision 119a11dfe2414910cd2dd3218210909b8b0d3e62)
@@ -19,2 +19,5 @@
 15. Add online help for inputs and outputs (especially figures of merit)
 16. Add help text to the interface (description of what we are minimizing, to explain alpha and nfunc).
+17. Get rid of all output prints.
+18. Clean up
+19. Replace help dialog text with a nice image. Mention how to choose alpha and what the suggested alpha means.